import { CodeOptionsSingleTheme, BundledTheme } from 'shiki';
import { ComponentProps, JSX } from 'solid-js';

type Theme = CodeOptionsSingleTheme<BundledTheme>['theme'];
/** A textarea with syntax highlighting capabilities powered by [shiki](https://github.com/shikijs/shiki). */
declare function ShikiTextarea(props: Omit<ComponentProps<'div'>, 'style'> & {
    /** Custom CSS properties to apply to the editor. */
    style?: JSX.CSSProperties;
    /** The source code to be displayed and edited. */
    value: string;
    /** The default source code to initialize the editor with. */
    defaultValue?: string;
    /** The theme to apply for syntax highlighting. */
    theme?: Theme;
    /** Callback function to handle updates to the source code. */
    onInput?: (source: string) => void;
    /** The programming language of the source code for syntax highlighting. */
    lang?: string;
}): JSX.Element;

export { ShikiTextarea };
